/**
 *  Water
 *  Author: Mahefa
 *  Description: 
 */

model Water

/* Insert your model definition here */

import "Globals.gaml"
import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

species Water parent :Superagent {	
	rgb color <- #blue  ;
	
	
	action move {
		float my_alt_hydr <- myPlot.altitude + myPlot.waterLevel ;
		Plot targetPlot <- myPlot ;
		loop onePlot over: myPlot.neighbours {
			float one_alt_hydr  <- onePlot.altitude + onePlot.waterLevel ;
			if(my_alt_hydr > one_alt_hydr) {
				my_alt_hydr <- one_alt_hydr ;
				targetPlot <- onePlot ;
			}
		}
		if(myPlot != targetPlot) {
			myPlot.waterLevel <- myPlot.waterLevel - 1.0 ;
			myPlot <- targetPlot ;
			myPlot.waterLevel <- myPlot.waterLevel + 1.0 ;
			location <-myPlot.location ;
		}
	}
	
	
	aspect base {
                draw circle(2) color: color ;
        }
             
} 
