/**
 *  House
 *  Author: Mahefa
 *  Description: 
 */

model House

/* Insert your model definition here */

import "Globals.gaml"
import "Experiment.gaml"
import "House.gaml"
import "Inhabitant.gaml"
import "Plot.gaml"
import "river.gaml"
import "road.gaml"
import "SuperAgent.gaml"
import "Water.gaml"

species House {
         
        list<Inhabitant> myInhabitant ;
        rgb color ;
        int hauteur <- 1 + rnd(5);
        
        aspect base {
        	// color <- #black ;
            draw shape depth: hauteur;
        }
        
        init {
        	do spit_Inhabitant ;
        }
      
        
        action spit_Inhabitant {
        	create Inhabitant number:1 {
        		location <- myself.location ;
        		myHouse <- myself ;
        	}  	
        }
}
